/*
        Copyright (C) 2017 Graham Jones, www.indriid.com

        This file is part of DENIM.

        DENIM is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        DENIM is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with DENIM.  If not, see <http://www.gnu.org/licenses/>.
*/

package denim;

import beast.base.core.BEASTObject;
import beast.base.core.Description;
import beast.base.core.Input;
import beast.base.core.Loggable;

import java.io.PrintStream;

@Description("Statistic for per-locus migration counts.")

public class MigrationCountStatistic extends BEASTObject implements Loggable {

    @SuppressWarnings({"CanBeFinal", "WeakerAccess"})
    public Input<CoalescenceMigrationDistribution> coalMigDistInput =
            new Input<>("coalMigDist",
                    "The CoalescenceMigrationDistribution",
                    Input.Validate.REQUIRED);


    public void initAndValidate() {

    }

    @Override
    public void init(PrintStream out) {
        for (int j = 0; j < coalMigDistInput.get().gTreeWEsInput.get().size(); j++) {
            out.print("MigCount-" + coalMigDistInput.get().getGtreeID(j) + "\t");
        }
    }

    @Override
    public void log(long nSample, PrintStream out) {
        for (int j = 0; j < coalMigDistInput.get().gTreeWEsInput.get().size(); j++) {
            out.print(coalMigDistInput.get().getMigrationCount(j) + "\t");
        }
    }

    @Override
    public void close(PrintStream out) {
        // nothing to do
    }

}
