/*
        Copyright (C) 2017 Graham Jones, www.indriid.com

        This file is part of DENIM.

        DENIM is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        DENIM is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with DENIM.  If not, see <http://www.gnu.org/licenses/>.
*/

package denim.util;

import beast.base.core.Description;

import java.util.Arrays;

/*
 * Created by GRJ on 02/06/2017.
 */

@Description("Utility class for DENIM which implements a mixture of gamma distributions.")
// It only implements the way the gammas are mixed; it is not a Distribution.
// Not yet used

public class GammaMixture {
    private final double [] weights;
    private final double [] alphas;
    private final double [] betas;

    public GammaMixture(int ncs) {
        weights = new double[ncs];
        alphas = new double[ncs];
        betas = new double[ncs];
    }

    public void setWeight(int c, double weight) {
        weights[c] = weight;
    }

    public void setAlpha(int c, double alpha) {
        alphas[c] = alpha;
    }

    public void setBeta(int c, double beta) {
        betas[c] = beta;
    }


    public double [] getWeights() {
        return Arrays.copyOf(weights, weights.length);
    }


    public double[] getAlphas() {
        return Arrays.copyOf(alphas, alphas.length);
    }


    public double[] getBetas() {
        return Arrays.copyOf(betas, betas.length);
    }

}
